# -*- coding: utf-8 -*-
import es
import hashlib
import time
import os
import installlib
import cmdlib
from configobj import ConfigObj
#import random
import gamethread
import popuplib
import re
import services


info = es.AddonInfo()
info.basename = 'chatadmin'
info.name = "ChatAdmin"
info.version = "3.0.4"
info.author = "Brainsucker"
info.description = "Allows Admins to Kick or Ban Players by Chat or Consolecommand!"
info.url = "http://addons.eventscripts.com/addons/view/Chatadmin"

addonpath = es.getAddonPath(info['basename']).replace("\\", "/")

config = ConfigObj(addonpath + "/chatadmin.ini")

kcmd = str(config["kickcmd"])
bcmd = str(config["bancmd"])
lm = int(config["load_message"])
unlm = int(config["unload_message"])
sm = int(config["show_message"])
san = int(config["show_admin_name"])
sr = int(config['show_reason'])
bt = int(config['show_bantime'])

time_to_kick = 5

#Thx to Superdave
#resid = re.compile(r'^STEAM\_0\:\d\:\d{6,8}$')

no_switch = []

left_players = {}

save_dict = {}

def load():
	global auth_service
	if hashlib.md5(info.author).hexdigest() == "e23f4403f295a005453317e0808f8f40":
		if services.isRegistered("auth"):
			auth_service = services.use("auth")
			auth_service.registerCapability("chatadmin_kick", auth_service.ADMIN)
			auth_service.registerCapability("chatadmin_ban", auth_service.ADMIN)
			auth_service.registerCapability('chatadmin_offlineban', auth_service.ADMIN)
			es.ServerVar(info.name, info.version).makepublic()
			
			updater = installlib.getInstaller(info['basename'])
			updater.update()
			
			if es.exists("saycommand", kcmd):
				cmdlib.unregisterSayCommand(kcmd)
			cmdlib.registerSayCommand(kcmd, fastkick, "Command for Admins to kick a player by chat")
			
			if es.exists("saycommand", bcmd):
				cmdlib.unregisterSayCommand(bcmd)
			cmdlib.registerSayCommand(bcmd, fastban, "Command for Admins to ban players by chat")
			
			if not es.exists("clientcommand", kcmd):
				cmdlib.unregisterClientCommand(kcmd)
			cmdlib.registerClientCommand(kcmd, fastkick, "Command for Admins to kick players by console")
			
			if es.exists("clientcommand", bcmd):
				cmdlib.unregisterClientCommand(bcmd)
			cmdlib.registerClientCommand(bcmd, fastban, "Command for Admins to ban players by chat")
		
			if lm:
				es.msg("#multi", "#default[#green%s#default] has been loaded..." % info.name)
				
		else:
			es.dbgmsg(0, "No AuthService has been found! Unloading..")
			es.unload("chatadmin")
			
def getSteamIDList():
	sidlist = []
	for player in es.getUseridList():
		sidlist.append(es.getplayersteamid(player))
	return sidlist
	
def convertbantime(textstring):
	tmpbantime = 0
	#Thx to Superdave
	r = re.compile('(\d+)([a-zA-Z]+)')
	bdict = dict((y, x) for x, y in r.findall(textstring.lower()))
	sucess = False
	if bdict.has_key("y"):
		if bdict["y"].isdigit():
			tmpbantime += years_to_minutes(int(bdict["y"]))
			sucess = True
	if bdict.has_key("m"):
		if bdict["m"].isdigit():
			tmpbantime += months_to_minutes(int(bdict["m"]))
			sucess = True
	if bdict.has_key("w"):
		if bdict["w"].isdigit():
			tmpbantime += weeks_to_minutes(int(bdict["w"]))
			sucess = True
	if bdict.has_key("d"):
		if bdict["d"].isdigit():
			tmpbantime += days_to_minutes(int(bdict["d"]))
			sucess = True
	if bdict.has_key("h"):
		if bdict["h"].isdigit():
			tmpbantime += hours_to_minutes(int(bdict["h"]))
			sucess = True
	if bdict.has_key("min"):
		if bdict["min"].isdigit():
			tmpbantime += int(bdict["min"])
			sucess = True
			
	return (sucess, tmpbantime)	
			
def getTimeText(time_in_minutes):
	text_list = []
	years = time_in_minutes/years_to_minutes(1)
	if years:
		text_list.append("%i Year(s)" % years)
	months = (time_in_minutes-years_to_minutes(years))/months_to_minutes(1)
	if months:
		text_list.append("%i Month(s)" % months)
	weeks = (time_in_minutes-years_to_minutes(years)-months_to_minutes(months))/weeks_to_minutes(1)
	if weeks:
		text_list.append("%i Week(s)" % weeks)
	days = (time_in_minutes-years_to_minutes(years)-months_to_minutes(months)-weeks_to_minutes(weeks))/days_to_minutes(1)
	if days:
		text_list.append("%i Day(s)" % days)
	hours = (time_in_minutes-years_to_minutes(years)-months_to_minutes(months)-weeks_to_minutes(weeks)-days_to_minutes(days))/hours_to_minutes(1)
	if hours:
		text_list.append("%i Hour(s)" % hours)
	minutes = (time_in_minutes-years_to_minutes(years)-months_to_minutes(months)-weeks_to_minutes(weeks)-days_to_minutes(days))-hours_to_minutes(hours)
	if minutes:
		text_list.append("%i Minute(s)" % minutes)
		
	full_ban_text = ", ".join(text_list)
			
	return full_ban_text
	
def processPunish(userid):
	steamid = es.getplayersteamid(userid)
	name = es.getplayername(userid)
	for psteamid in save_dict[steamid]["chosen"]:
		on_server = False
		x = None
		pname = "Unknown"
		if psteamid in getSteamIDList():
			on_server = True
			x = es.getuserid(psteamid)
			pname = es.getplayername(x)
		if not on_server:
			if left_players.has_key(psteamid):
				pname = left_players[psteamid]['lastname']
				
		m = 'Not specified'
		
		if save_dict[steamid]["reason"]:
			m = save_dict[steamid]["reason"]
			
				
		if save_dict[steamid]["type"] == "kick":
			if on_server:
				log(name, steamid, pname, psteamid, save_dict[steamid]["type"], save_dict[steamid]["reason"], None)
				es.tell(x, "********************")
				es.tell(x, "You have been kicked by an Admin.")
				es.tell(x, "Adminname: %s" % name)
				es.tell(x, "Reason for kick: %s" % m)
				es.tell(x, "********************")
				gamethread.delayed(0.5, es.server.queuecmd, "kickid %s Kicked by Admin" % x)
				if sm:
					es.msg("#multi", "#default[ADMIN%s] Kicked Player #green%s#default.%s" % ((" #green%s#default" % name) if san else "", pname, (' Reason: #green%s#default.' % m) if sr else ''))
					
		if save_dict[steamid]["type"] == "ban":
			if on_server:
				es.server.queuecmd("es_xchangeteam %s 1" % x)
				no_switch.append(psteamid)
				
				for y in xrange(time_to_kick):
					gamethread.delayed(y, es.tell, (x, "#multi", "#greenPlease check your console for details! #defaultDisconnect in %i Seconds" % (time_to_kick-y)))
				gamethread.delayed(time_to_kick, es.server.queuecmd, ("kickid %s Banned by Admin" % x))
				
				bantime_text = getTimeText(save_dict[steamid]["bantime"])
				
				es.tell(x, "#multi" ,"#default********************")
				es.tell(x, "#multi", "#defaultYou have been banned by an Admin.")
				es.tell(x, "#multi", "#defaultAdminname: %s" % name)
				if save_dict[steamid]["bantime"] == 0:
					es.tell(x, "#multi", "#defaultBantime: PERMANENT")
				else:
					es.tell(x, "#multi", "#defaultBantime: %s" % bantime_text)
				es.tell(x, "#multi", "#defaultReason for ban: %s" % m)
				es.tell(x, "#multi", "#default********************")
				if sm:
					es.msg("#multi", "#default[ADMIN%s] Banned Player #green%s#default.%s%s" % ((" #green%s#default" % name) if san else "", pname, (' Bantime: #green%s#default.' % bantime_text) if bt else '', (' Reason: #green%s#default.' % m) if sr else ''))
			else:
				es.tell(userid, "#multi", "#defaultSuccessfully banned STEAMID #green%s #default with reason #green%s" % (psteamid, m))
				
			log(name, steamid, pname, psteamid, save_dict[steamid]["type"], save_dict[steamid]["reason"], save_dict[steamid]["bantime"])
			
			es.server.queuecmd("banid %s %s" % (save_dict[steamid]["bantime"], psteamid))
			
			if save_dict[steamid]["bantime"] == 0:
				es.server.queuecmd("writeid")
				
def left_players_select(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	if choice == 'execute':
		processPunish(userid)
		
	elif choice == 'go_back':
		choosePlayers(userid)
		
		
	else:
		if choice in save_dict[steamid]['chosen']:
			save_dict[steamid]['chosen'].remove(choice)
		else:
			save_dict[steamid]['chosen'].append(choice)
			
		showLeftPlayers(userid)
		
def showLeftPlayers(userid):
	steamid = es.getplayersteamid(userid)
	if popuplib.exists('chatadmin_leftplayers'):
		popuplib.delete('chatadmin_leftplayers')

	lp = popuplib.easymenu('chatadmin_leftplayers', None, left_players_select)
	lp.settitle('Choose the Players you want to ban:')
	if len(save_dict[steamid]['chosen']) > 0:
		lp.addoption('execute', 'Ban them!')
	else:
		lp.addoption('go_back', 'Back to current Players')
	for x in left_players.keys():
		lp.addoption(x, ('* ' if x in save_dict[steamid]['chosen'] else '') + left_players[x]['lastname'])
		
	lp.send(userid)
				
def popup_choice(userid, choice, popupid):
	steamid = es.getplayersteamid(userid)
	if choice == "execute":
		processPunish(userid)
					
					
	elif choice == 'left_player':
		showLeftPlayers(userid)
					
	else:
		if choice in save_dict[steamid]["chosen"]:
			save_dict[steamid]["chosen"].remove(choice)
		else:
			save_dict[steamid]["chosen"].append(choice)
			
		choosePlayers(userid)
		
def choosePlayers(userid):
	steamid = es.getplayersteamid(userid)
	if popuplib.exists("chatadmin_playerpopup"):
		popuplib.delete("chatadmin_playerpopup")
	capp = popuplib.easymenu("chatadmin_playerpopup", None, popup_choice)
	capp.settitle("Choose the Players you want to %s\nwith the reason: %s" % (save_dict[steamid]["type"], save_dict[steamid]["reason"]))
	if len(save_dict[steamid]["chosen"]):
		capp.addoption("execute", "%s them!" % save_dict[steamid]["type"].capitalize())
	else:
		if save_dict[steamid]["type"] == 'ban':
			if auth_service.isIdAuthorized(steamid, 'chatadmin_offlineban'):
				capp.addoption('left_player', 'Ban left Player(s)')
	for player in es.getUseridList():
		if not es.isbot(player):
			sid = es.getplayersteamid(player)
			capp.addoption(sid, ("*" if sid in save_dict[steamid]["chosen"] else "") + es.getplayername(player))
	capp.send(userid)


def fastkick(userid, args):
	if len(args) > 0:
		args = str(args).split()
	steamid = es.getplayersteamid(userid)
	name = es.getplayername(userid)
	if auth_service.isIdAuthorized(steamid, "chatadmin_kick"):
		save_dict[steamid] = {}
		save_dict[steamid]["type"] = "kick"
		save_dict[steamid]["chosen"] = []
		

		kickreason = None
		if len(args):
			kickreason = " ".join(args)
		
		save_dict[steamid]["reason"] = kickreason
				
		choosePlayers(userid)
		
	else:
		es.tell(userid, '#multi', '#defaultYou are not authorized to use this command')

def fastban(userid, args):
	if len(args) > 0:
		args = str(args).split()
	steamid = es.getplayersteamid(userid)
	name = es.getplayername(userid)
	if auth_service.isIdAuthorized(steamid, "chatadmin_ban"):
		save_dict[steamid] = {}
		save_dict[steamid]["chosen"] = []
		save_dict[steamid]["type"] = "ban"
		
		if len(args) >= 2:
			arg1 = args[0]
			if str(arg1).isdigit():
				bantime = int(arg1)

			else:
				sucess, bantime = convertbantime(arg1)
				if not sucess:
					giveBanExample(userid)
					return
					
			save_dict[steamid]["bantime"] = bantime

			banreason = None
			if len(args) > 1:
				banreason = " ".join(args).replace(arg1 + " ", "")
				
			
			save_dict[steamid]["reason"] = banreason
			
			
			choosePlayers(userid)
			
		else:
			giveBanExample(userid)
			
	else:
		es.tell(userid, '#multi', '#defaultYou are not authorized to use this command')
			
def years_to_minutes(y):
	return days_to_minutes(y*360)

def months_to_minutes(m):
	return days_to_minutes(m*30)
	
def weeks_to_minutes(w):
	return days_to_minutes(w*7)
	
def days_to_minutes(d):
	return hours_to_minutes(d*24)
	
def hours_to_minutes(h):
	return (h*60)
			
def unload():
	cmdlib.unregisterSayCommand(kcmd)
	cmdlib.unregisterSayCommand(bcmd)
	cmdlib.unregisterClientCommand(kcmd)
	cmdlib.unregisterClientCommand(bcmd)
	if unlm:
		es.msg("#multi", "#default[#green%s#default] has been unloaded..." % info.name)
		


def exists(a, b):
	uidlist = es.getUseridList()
	if a == "playername":
		for player in uidlist:
			if b == es.getplayername(player):
				return True

	if a == "userid":
		return (int(b) in uidlist)

	if a == "steamid":
		return (b in getSteamIDList())
		
	return False 

def checkuserid(argument):
	if str(argument).isdigit():
		if exists("userid", int(argument)):
			return argument

	if exists("steamid", argument):
		return es.getuserid(argument)

	if exists("playername", argument):
		return es.getuserid(argument)

	return False

def log(adminname, adminsteamid, username, usersteamid, punishtype, reason=None, bantime=None):
	logfile = open(addonpath + "/adminlog.txt", "ab")
	t = time.strftime("%X")
	d = time.strftime("%d.%m.%Y")
	if punishtype == "kick":
		logfile.write("\n\n-----\nKicked:")

	if punishtype == "ban":
		logfile.write("\n\n-----\nBanned:")

	logfile.write("\nDate: %s\nTime: %s\n\nAdmin:\nName: %s\nSTEAMID: %s\n\nUser:\nName: %s\nSTEAMID: %s" % (d, t, adminname, adminsteamid, username, usersteamid))

	if bantime != None:
		if bantime == 0:
			logfile.write("\nBantime: PERMANENT")

		else:
			logfile.write("\nBantime: %s" % getTimeText(bantime))

	if reason:
		logfile.write("\n\nReason: %s" % reason)
		
	if not usersteamid in getSteamIDList():
		logfile.write('\nNotes:\nOffline Ban')

	logfile.write("\n-----")
		
	logfile.flush()
	logfile.close()
	
def player_team(ev):
	steamid = ev["es_steamid"]
	userid = ev["userid"]
	if no_switch.count(steamid):
		if ev["newteam"] != "1":
			es.server.queuecmd("es_xchangeteam %s 1" % userid)
			
def player_disconnect(ev):
	steamid = ev["networkid"]
	if no_switch.count(steamid):
		no_switch.remove(steamid)
	if not left_players.has_key(steamid):
		left_players[steamid] = {}
		
	left_players[steamid]['lastname'] = ev['name']
	
def es_player_validated(ev):
	steamid = ev['networkid']
	if left_players.has_key(steamid):
		del left_players[steamid]
		


def giveKickExample(userid):
	popuplib.quicksend(0, userid, 'How to use: %s <Reason>\n\nExample:\n%s AFK too long\n\nAfter this Chat or Console entry a popup will appear where you can choose all the Players you want to kick. Choose them and then press \'Kick Them!\'.' % (kcmd, kcmd))


def giveBanExample(userid):
	popuplib.quicksend(0, userid, 'How to use: %s <Bantime (0 = Permanent)> <Reason>\n\nExample:\n%s 30 Breaking Serverrules\n\nAfter this Chat or Console entry a popup will appear where you can choose all the Players you want to ban. Choose them and then press \'Ban Them!\'.\nYou can also use to following subcommands to exactly specify the bantime:\nh = Hours, d = Days, w = Weeks, m = Months, y = Years\nIf you use 2m3w as bantime, this would ban the specified User(s) for 2 Months and 3 Weeks.\n' % (bcmd, bcmd))